;;;; exports.scm


(declare
  (export
   fps:pi fps:1/4pi fps:1/2pi fps:3/4pi fps:5/4pi fps:3/2pi fps:7/4pi fps:2pi
   fps:origin
   fps:identity-matrix
   fps:afm-directory-list

   ;; font
   fps:font?
   fps:font

   ;; Point and Matrix
   fps:pt? fps:pt=
   fps:pt fps:pt:x fps:pt:y
   fps:add-pts  fps:negate-pt  fps:scale-pt

   fps:matrix? fps:matrix=
   fps:matrix fps:matrix*

   ;; Path Makers
   fps:path?
   fps:line 
   fps:rect
   fps:arc 
   fps:tangent-arc 
   fps:curve 
   fps:close-path 
   fps:stroke-outline-path 
   fps:bitmap->path
   fps:bounding-box->rect
   fps:the-empty-path

   ;; glyphs construction
   fps:char->glyphpath
   fps:int->glyphpath
   fps:glyphname->glyphpath
   fps:vector->glyphpath
   fps:simple-string->glyphpath
   fps:string->glyphpath

   ;; Picture Makers
   fps:picture?
   fps:stroke fps:fill fps:clip fps:colormap fps:bitmap->pict
   fps:paint-glyphpath
   fps:the-empty-pict

   ;; combination
   fps:compose       fps:compose-path   fps:compose-pict
   fps:join          fps:join-path      fps:join-pict
   fps:link

   ;; transformation
   fps:translate fps:rotate fps:scale

   ;; style
   fps:style?
   fps:vary-default
   fps:build-style	  
   fps:with-style*
   fps:default-style

   ;; attributes
   fps:attrib?
   fps::color        fps::line-cap     fps::line-width 
   fps::dash-pattern fps::dash-offset  
   fps::line-join    fps::miter-limit

   ;; colors
   fps:color?   fps:color=
   fps:gray     fps:gray:val
   fps:rgb      fps:rgb:r  fps:rgb:g  fps:rgb:b
   fps:hsb      fps:hsb:h  fps:hsb:s  fps:hsb:b
   fps:cmyk     fps:cmyk:c fps:cmyk:m fps:cmyk:y fps:cmyk:k

   ;; char map
   fps:char-map?
   fps:base-char-map
   fps:lookup-char-map
   fps:function->char-map 
   fps:alist->char-map 
   fps:mask-char-map 
   fps:native-font-char-map

   ;; int map
   fps:int-map?
   fps:base-int-map
   fps:lookup-int-map
   fps:function->int-map
   fps:alist->int-map
   fps:mask-int-map
   fps:native-font-int-map

   ;; object info
   fps:start-pt      
   fps:end-pt
   fps:bounding-box  
   fps:bounding-box:max fps:bounding-box:min

   ;; channel
   fps:channel?
   fps:show
   fps:show-w/ps2-text-channel
   fps:ps2-text-channel
   fps:close-channel

   ;; bitmap
   fps:bitmap?
   fps:vector->bitmap
   fps:hex-string->bitmap
   fps:bin-string->bitmap

   ;; options
   fps::format
   fps::creator      fps::creation-date  fps::title
   fps::copyright    fps::for            fps::routing
   fps::duplex       fps::duplex-tumble  fps::collate  
   fps::num-copies   fps::orientation
   fps::page-label

   ;; util
   fps:deg->rad fps:rad->deg
   fps:inch

   ;; faked syntax-case module...
   fps$$pi fps$$1/4pi fps$$1/2pi fps$$3/4pi fps$$5/4pi fps$$3/2pi fps$$7/4pi fps$$2pi
   fps$$origin
   fps$$identity-matrix
   fps$$afm-directory-list

   ;; font
   fps$$font?
   fps$$font

   ;; Point and Matrix
   fps$$pt? fps$$pt=
   fps$$pt fps$$pt:x fps$$pt:y
   fps$$add-pts  fps$$negate-pt  fps$$scale-pt

   fps$$matrix? fps$$matrix=
   fps$$matrix fps$$matrix*

   ;; Path Makers
   fps$$path?
   fps$$line 
   fps$$rect
   fps$$arc 
   fps$$tangent-arc 
   fps$$curve 
   fps$$close-path 
   fps$$stroke-outline-path 
   fps$$bitmap->path
   fps$$bounding-box->rect
   fps$$the-empty-path

   ;; glyphs construction
   fps$$char->glyphpath
   fps$$int->glyphpath
   fps$$glyphname->glyphpath
   fps$$vector->glyphpath
   fps$$simple-string->glyphpath
   fps$$string->glyphpath

   ;; Picture Makers
   fps$$picture?
   fps$$stroke fps$$fill fps$$clip fps$$colormap fps$$bitmap->pict
   fps$$paint-glyphpath
   fps$$the-empty-pict

   ;; combination
   fps$$compose       fps$$compose-path   fps$$compose-pict
   fps$$join          fps$$join-path      fps$$join-pict
   fps$$link

   ;; transformation
   fps$$translate fps$$rotate fps$$scale

   ;; style
   fps$$style?
   fps$$vary-default
   fps$$build-style	  
   fps$$with-style*

   ;; attributes
   fps$$attrib?
   fps$$:color        fps$$:line-cap     fps$$:line-width 
   fps$$:dash-pattern fps$$:dash-offset  
   fps$$:line-join    fps$$:miter-limit

   ;; colors
   fps$$color?   fps$$color=
   fps$$gray     fps$$gray:val
   fps$$rgb      fps$$rgb:r  fps$$rgb:g  fps$$rgb:b
   fps$$hsb      fps$$hsb:h  fps$$hsb:s  fps$$hsb:b
   fps$$cmyk     fps$$cmyk:c fps$$cmyk:m fps$$cmyk:y fps$$cmyk:k

   ;; char map
   fps$$char-map?
   fps$$base-char-map
   fps$$lookup-char-map
   fps$$function->char-map 
   fps$$alist->char-map 
   fps$$mask-char-map 
   fps$$native-font-char-map

   ;; int map
   fps$$int-map?
   fps$$base-int-map
   fps$$lookup-int-map
   fps$$function->int-map
   fps$$alist->int-map
   fps$$mask-int-map
   fps$$native-font-int-map

   ;; object info
   fps$$start-pt      
   fps$$end-pt
   fps$$bounding-box  
   fps$$bounding-box:max fps$$bounding-box:min

   ;; channel
   fps$$channel?
   fps$$show
   fps$$show-w/ps2-text-channel
   fps$$ps2-text-channel
   fps$$close-channel

   ;; bitmap
   fps$$bitmap?
   fps$$vector->bitmap
   fps$$hex-string->bitmap
   fps$$bin-string->bitmap

   ;; options
   fps$$:format
   fps$$:creator      fps$$:creation-date  fps$$:title
   fps$$:copyright    fps$$:for            fps$$:routing
   fps$$:duplex       fps$$:duplex-tumble  fps$$:collate  
   fps$$:num-copies   fps$$:orientation
   fps$$:page-label

   ;; util
   fps$$deg->rad fps$$rad->deg
   fps$$inch
   ) )

(define fps:pi pi) 
(define fps:1/4pi 1/4pi)
(define fps:1/2pi 1/2pi)
(define fps:3/4pi 3/4pi)
(define fps:5/4pi 5/4pi)
(define fps:3/2pi 3/2pi)
(define fps:7/4pi 7/4pi)
(define fps:2pi 2pi)
(define fps:origin origin)
(define fps:identity-matrix identity-matrix)
(define fps:afm-directory-list afm-directory-list)

;; font
(define fps:font? font?)
(define fps:font font)

;; Point and Matrix
(define fps:pt? pt?) (define fps:pt= pt=)
(define fps:pt pt) (define fps:pt:x pt:x) (define fps:pt:y pt:y)
(define fps:add-pts add-pts)  (define fps:negate-pt negate-pt)  (define fps:scale-pt scale-pt)

(define fps:matrix? matrix?) (define fps:matrix= matrix=)
(define fps:matrix matrix) (define fps:matrix* matrix*)

;; Path Makers
(define fps:path? path?)
(define fps:line line) 
(define fps:rect rect)
(define fps:arc arc) 
(define fps:tangent-arc tangent-arc) 
(define fps:curve curve) 
(define fps:close-path close-path) 
(define fps:stroke-outline-path stroke-outline-path) 
(define fps:bitmap->path bitmap->path)
(define fps:bounding-box->rect bounding-box->rect)
(define fps:the-empty-path the-empty-path)

;; glyphs construction
(define fps:char->glyphpath char->glyphpath)
(define fps:int->glyphpath int->glyphpath)
(define fps:glyphname->glyphpath glyphname->glyphpath)
(define fps:vector->glyphpath vector->glyphpath)
(define fps:simple-string->glyphpath simple-string->glyphpath)
(define fps:string->glyphpath string->glyphpath)

;; Picture Makers
(define fps:picture? picture?)
(define fps:stroke stroke)
(define fps:fill fill) (define fps:clip clip) (define fps:colormap colormap) (define fps:bitmap->pict bitmap->pict)
(define fps:paint-glyphpath paint-glyphpath)
(define fps:the-empty-pict the-empty-pict)

;; combination
(define fps:compose compose)       (define fps:compose-path compose-path)   (define fps:compose-pict compose-pict)
(define fps:join join)          (define fps:join-path join-path)      (define fps:join-pict join-pict)
(define fps:link link)

;; transformation
(define fps:translate translate) (define fps:rotate rotate) (define fps:scale scale)

;; style
(define fps:style? style?)
(define fps:vary-default vary-default)
(define fps:build-style build-style)	  
(define fps:with-style* with-style*)
(define fps:default-style default-style)

;; attributes
(define fps:attrib? attrib?)
(define fps::color :color)        (define fps::line-cap :line-cap)     (define fps::line-width :line-width) 
(define fps::dash-pattern :dash-pattern) (define fps::dash-offset :dash-offset)  
(define fps::line-join :line-join)    (define fps::miter-limit :miter-limit)

;; colors
(define fps:color? color?)   (define fps:color= color=)
(define fps:gray gray)     (define fps:gray:val gray:val)
(define fps:rgb rgb)      (define fps:rgb:r rgb:r)  (define fps:rgb:g rgb:g)  (define fps:rgb:b rgb:b)
(define fps:hsb hsb)      (define fps:hsb:h hsb:h)  (define fps:hsb:s hsb:s)  (define fps:hsb:b hsb:b)
(define fps:cmyk cmyk)     (define fps:cmyk:c cmyk:c) (define fps:cmyk:m cmyk:m) (define fps:cmyk:y cmyk:y) (define fps:cmyk:k cmyk:k)

;; char map
(define fps:char-map? char-map?)
(define fps:base-char-map base-char-map)
(define fps:lookup-char-map lookup-char-map)
(define fps:function->char-map function->char-map)
(define fps:alist->char-map alist->char-map )
(define fps:mask-char-map mask-char-map) 
(define fps:native-font-char-map native-font-char-map)

;; int map
(define fps:int-map? int-map?)
(define fps:base-int-map base-int-map)
(define fps:lookup-int-map lookup-int-map)
(define fps:function->int-map function->int-map)
(define fps:alist->int-map alist->int-map)
(define fps:mask-int-map mask-int-map)
(define fps:native-font-int-map native-font-int-map)

;; object info
(define fps:start-pt start-pt)      
(define fps:end-pt end-pt)
(define fps:bounding-box bounding-box)  
(define fps:bounding-box:max bounding-box:max) (define fps:bounding-box:min bounding-box:min)

;; channel
(define fps:channel? channel?)
(define fps:show show)
(define fps:show-w/ps2-text-channel show-w/ps2-text-channel)
(define fps:ps2-text-channel ps2-text-channel)
(define fps:close-channel close-channel)

;; bitmap
(define fps:bitmap? bitmap?)
(define fps:vector->bitmap vector->bitmap)
(define fps:hex-string->bitmap hex-string->bitmap)
(define fps:bin-string->bitmap bin-string->bitmap)

;; options
(define fps::format :format)
(define fps::creator :creator)      (define fps::creation-date :creation-date)  (define fps::title :title)
(define fps::copyright :copyright)    (define fps::for :for)            (define fps::routing :routing)
(define fps::duplex :duplex)       (define fps::duplex-tumble :duplex-tumble)  (define fps::collate :collate)  
(define fps::num-copies :num-copies)   (define fps::orientation :orientation)
(define fps::page-label :page-label)

;; util
(define fps:deg->rad deg->rad) (define fps:rad->deg rad->deg)
(define fps:inch inch)
