;;;; fps-base.scm

(use srfi-1)  ;; for filter
(use srfi-69) ;; for hash-table
(use regex)   ;; for string-split-fields

(use syntax-case)
(use records utils format-modular)

(define (field-splitter rx) 
  (lambda (str #!optional (start 0))
    (string-split-fields rx str #t start) ) )

(define (infix-splitter rx) 
  (lambda (str #!optional (start 0))
    (string-split-fields rx str #:infix start) ) )

(define (suffix-splitter rx) 
  (lambda (str #!optional (start 0))
    (string-split-fields rx str #:suffix start) ) )

(define char->ascii char->integer)
(define ascii->char integer->char)

(define (make-string-table) (make-hash-table string=?))
(define table-ref (cut hash-table-ref/default <> <> #f))
(define table-set! hash-table-set!)

(include "conditionals")
(include "defrec")
(include "fps.type")
(include "fps.color")
(include "fps.util")
(include "fps-global")
(include "fps.glyph")
(include "fps.comp")
(include "fps.paint")
(include "fps.map")
(include "fps.afm")
(include "fps.ask")
(include "fps.show")
(include "fps.mat")
(include "fps.style")
(include "fps.bitmap")
(include "fps.options")
(include "ps.path")
(include "ps.misc")
(include "exports")

(define-record-printer (pt p port)
  (format port "#<pt ~s/~s>" (pt:x p) (pt:y p)))

(provide 'fps-base)
(include "fps")
